SystemOrganization addCategory: #'Phidget-Lab'!

PolygonMorph subclass: #PhdLabWire
	instanceVariableNames: 'startpoint endpoint dragEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

!PhdLabWire class methodsFor: 'as yet unclassified' stamp: 'sp 5/7/2009 22:00'!
from: startPoint to: endPoint

	^ (super new) initializeFrom: startPoint to: endPoint.! !

!PhdLabWire class methodsFor: 'as yet unclassified' stamp: 'sp 5/7/2009 22:06'!
new
	self error: 'Use ',self name, ' from: aPoint to: aPoint'.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 23:41'!
acceptDroppingMorph: aMorph event: anEvent

	self stopStepping.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/7/2009 13:09'!
endpoint

	^ endpoint! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:52'!
initializeFrom: startPoint to: endPoint

	self
		setVertices: {startPoint. endPoint};
		color: Color black;
		stopStepping.
	closed := false.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 23:39'!
rejectDropMorphEvent: anEvent

	self delete.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:46'!
setEndpoint: aPoint

	vertices at: vertices size put: aPoint.	
	endpoint := aPoint.
! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:43'!
setStartpoint: aPoint

	vertices at: 1 put: aPoint.
	startpoint := aPoint.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/7/2009 13:08'!
startpoint

	^ startpoint! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:08'!
step
		"wire will be only created by dragging from a Morph to another one.
		 during this, the endpoint has to be changed to hand position"
		
		self setEndpoint: self currentWorld activeHand cursorPoint.! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 22:33'!
stepTime

	^ 100! !

!PhdLabWire methodsFor: 'accessing' stamp: 'sp 5/9/2009 23:56'!
wantsToBeDroppedInto: aMorph 
	"I want to be dropped onto a PhdLabConnector"

	^ (aMorph isKindOf: PhdLabConnector "&...")
! !

BorderedMorph subclass: #PhdLabConnector
	instanceVariableNames: 'connector type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/7/2009 08:18'!
click: anEvent
	"ignore this event, wait for drag:"

	^ self! !

!PhdLabConnector methodsFor: 'accessing' stamp: 'sp 5/4/2009 21:12'!
connector

	^ connector! !

!PhdLabConnector methodsFor: 'accessing' stamp: 'sp 5/4/2009 21:13'!
connector: aPhdLbConnector

	connector := aPhdLbConnector.! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/7/2009 08:46'!
doubleClick: anEvent
	"ignore this event, wait for drag:"

	^ self! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:50'!
drag: anEvent
	"currently not in use!!!!!!!!!!!!!!!!!!!!"
	
	| wire |
	wire :=  PhdLabWire
		from: self center 
		to: self currentWorld activeHand cursorPoint.
"	wire dragEvent: anEvent."
	wire
		openInWorld;
		startStepping.

	"anEvent hand addEventListener: wire"! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:31'!
enableDrop: aBoolean

	^ true! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:46'!
firstClickTimedOut: anEvent
	"start drag with hand grabbing wire"
	
	| wire |
	wire :=  PhdLabWire
		from: self center 
		to: self currentWorld activeHand cursorPoint.
"	wire dragEvent: anEvent."
	wire
		openInWorld;
		startStepping.

	anEvent hand grabMorph: wire.
	"anEvent hand addEventListener: wire"! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/7/2009 08:01'!
handlesMouseDown: anEvent

	^ true! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/8/2009 10:48'!
handlesMouseUp: anEvent

	^ true! !

!PhdLabConnector methodsFor: 'initialize' stamp: 'sp 5/9/2009 23:16'!
initialize

	super initialize.
	
	self
		connector: nil;
		type: #unknown;
		
		color: ( Color r: 0.816 g: 0.812 b: 0.812 );
		extent: 20@20;
		borderWidth: 1;
		useRoundedCorners.! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:51'!
mouseDown: anEvent
	"when mouseDown-event inform the hand to watch for a drag: message (do we have to catch the other events??-like click)"

	"catch if okToPickUp is ok??" "what happend when user doesn't drag?'"
	
	anEvent hand 
		waitForClicksOrDrag: self
		event: anEvent
		selectors: #(#click: #doubleClick: #firstClickTimedOut: nil)	"#drag-->nil"
		threshold: 3.! !

!PhdLabConnector methodsFor: 'accessing' stamp: 'sp 5/4/2009 21:13'!
type

	^ type! !

!PhdLabConnector methodsFor: 'accessing' stamp: 'sp 5/4/2009 21:14'!
type: aSymbol
	"or we take two methods isInput and isOutput"

	type := aSymbol.! !

!PhdLabConnector methodsFor: 'mouse events' stamp: 'sp 5/9/2009 23:56'!
wantsDroppedMorph: aMorph event: anEvent 
	"ask if it's a wire'"
	
	( aMorph isKindOf: PhdLabWire )		"wir sollten ja nicht kindOf nehm"
	ifTrue: [ ^ true "&..."]		"i/o abfragen msste der owner vom Connector dann wissen"
	ifFalse: [^ false]				"--> ^ self owner is***"! !

BorderedMorph subclass: #PhdLabInterfaceKit
	instanceVariableNames: 'ifKit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

BorderedMorph subclass: #PhdLabSlider
	instanceVariableNames: 'pick max min maxValue minValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Lab'!

!PhdLabSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:00'!
initialize

	super initialize.
	self color: Color blue lighter;
		width: 50;
		height: 200.
	pick := BorderedMorph new.
	pick color: Color black;
		width: 40;
		height: 20.
	self addMorph: pick.
	pick
		left: ( self left + 5 );
		top: ( self top + 5 ).
	min := 0.
	max := ( self bottom - 5 ) - ( self top + 5 ) - pick height.
	minValue := 0.
	maxValue := 100.
	! !

!PhdLabSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:02'!
rawValue: aNumber
	"0 <= aNumber <= 1000"
	"pick top: self bottom - 5 - pick height - (aNumber/1000*max)."

	pick top: self top + 5 + ( ( 1000 - aNumber ) / 1000 * max ).! !

!PhdLabSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:26'!
setMin: aSmallNumber andMax: aBigNumber

	minValue := aSmallNumber.
	maxValue := aBigNumber.! !

!PhdLabSlider methodsFor: 'as yet unclassified' stamp: 'sp 4/26/2009 13:40'!
value

	^ ( pick top - self top - 5 ) * maxValue / minValue! !
